"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FlagcandprofRawMapper = exports.FlagcandprofMongoMapper = void 0;
const aw_core_1 = require("@alien-worlds/aw-core");
const aw_storage_mongodb_1 = require("@alien-worlds/aw-storage-mongodb");
const entities_1 = require("../../domain/entities");
class FlagcandprofMongoMapper extends aw_storage_mongodb_1.MongoMapper {
    constructor() {
        super();
        this.mappingFromEntity.set('cand', {
            key: 'cand',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('reason', {
            key: 'reason',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('reporter', {
            key: 'reporter',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('block', {
            key: 'block',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('dacId', {
            key: 'dac_id',
            mapper: (value) => value,
        });
    }
    toEntity(mongoModel) {
        const { cand, reason, reporter, block, dac_id, _id, ...rest } = mongoModel;
        return entities_1.Flagcandprof.create(cand || '', reason || '', reporter || '', block || false, dac_id || '', _id instanceof aw_storage_mongodb_1.MongoDB.ObjectId ? _id.toString() : undefined, rest);
    }
}
exports.FlagcandprofMongoMapper = FlagcandprofMongoMapper;
class FlagcandprofRawMapper extends aw_core_1.MapperImpl {
    fromEntity(entity) {
        throw new Error('Method not implemented');
    }
    toEntity(rawModel) {
        const { cand, reason, reporter, block, dac_id, ...rest } = rawModel;
        return entities_1.Flagcandprof.create(cand || '', reason || '', reporter || '', block || false, dac_id || '', undefined, rest);
    }
}
exports.FlagcandprofRawMapper = FlagcandprofRawMapper;
