"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SetbudgetRawMapper = exports.SetbudgetMongoMapper = void 0;
const aw_core_1 = require("@alien-worlds/aw-core");
const aw_storage_mongodb_1 = require("@alien-worlds/aw-storage-mongodb");
const entities_1 = require("../../domain/entities");
class SetbudgetMongoMapper extends aw_storage_mongodb_1.MongoMapper {
    constructor() {
        super();
        this.mappingFromEntity.set('dacId', {
            key: 'dac_id',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('percentage', {
            key: 'percentage',
            mapper: (value) => value,
        });
    }
    toEntity(mongoModel) {
        const { dac_id, percentage, _id, ...rest } = mongoModel;
        return entities_1.Setbudget.create(dac_id || '', percentage || 0, _id instanceof aw_storage_mongodb_1.MongoDB.ObjectId ? _id.toString() : undefined, rest);
    }
}
exports.SetbudgetMongoMapper = SetbudgetMongoMapper;
class SetbudgetRawMapper extends aw_core_1.MapperImpl {
    fromEntity(entity) {
        throw new Error('Method not implemented');
    }
    toEntity(rawModel) {
        const { dac_id, percentage, ...rest } = rawModel;
        return entities_1.Setbudget.create(dac_id || '', percentage || 0, undefined, rest);
    }
}
exports.SetbudgetRawMapper = SetbudgetRawMapper;
